﻿using System.Diagnostics;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using Syncfusion_178454.Models;
using Syncfusion.EJ2.Base;

namespace Syncfusion_178454.Controllers;

public class HomeController : Controller
{
    private readonly ILogger<HomeController> _logger;

    public HomeController(ILogger<HomeController> logger)
    {
        _logger = logger;
    }

    public IActionResult Index()
    {
        ViewBag.DropDownSource = new Guid("f2a778a9-e0d3-4fda-a8cb-a6d778f5215b");

        ViewBag.MultiselectSource = new List<Guid>()
        {
            new Guid("84c29223-e92e-4471-b268-a06fcc17aa66"),
            new Guid("f2a778a9-e0d3-4fda-a8cb-a6d778f5215b")
        };
        
        ViewBag.GridDataSource = new List<GridItem>()
        {
            new GridItem()
            {
                Id = new Guid("34B5E77D-D236-4658-ABDF-C5A82762A78E"),
                Text = "First item",
                DropdownItemId = new Guid("db71cf16-f97d-4b48-88f8-19d1a11521c0"),
                DropdownItemText = "Guerra Johnson"
            },
            new GridItem()
            {
                Id = new Guid("0872B8DA-2595-4EF4-A6C3-F3A57A06641B"),
                Text = "Second item",
                DropdownItemId = new Guid("d8635fda-9f79-4c58-9ce5-8db536c6ad5b"),
                DropdownItemText = "Nicholson Gill"
            },
        };
        
        return View();
    }

    /// <summary>
    /// Simple method that is imitating database query.
    /// </summary>
    /// <param name="request"></param>
    /// <returns></returns>
    [HttpPost]
    public IActionResult FetchDropdownData([FromBody] DataManagerRequest request)
    {
        var items = JsonConvert.DeserializeObject<List<DropdownItem>>(System.IO.File.ReadAllText("Data/generated.json"));

        var resultQuery = items.AsQueryable();

        var textFilter = request.Where?.SingleOrDefault(r => r.Field.ToLower() == "text");
        var idFilter = request.Where?.SingleOrDefault(r => r.Field.ToLower() == "id");

        if (textFilter != null)
        {
            resultQuery = resultQuery.Where(p => p.Text.Contains(textFilter.value.ToString()));
        }
        if (idFilter != null)
        {
            resultQuery = resultQuery.Where(p => p.Id == new Guid(idFilter.value.ToString()));
        }
        
        var result = resultQuery
            .Skip(request.Skip)
            .Take(request.Take)
            .ToList();

        return request.RequiresCounts ? Json(new { result = result, count = result.Count }) : Json(result);
    }

    public IActionResult Privacy()
    {
        return View();
    }

    [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
    public IActionResult Error()
    {
        return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
    }
}